`timescale 10ps / 10ps
`define GTK // use VCD

`include "rtavr_defs.v"

`define MODULE	tb_rom
`define CLK_LIMIT	200

module `MODULE;

   reg [15:0] CLK_COUNT;
   reg CLK2X;  // input
   reg RESET;  // input

//   wire [4:0] INT_VEC; // output
//   wire INT_REQ; // output
//   wire INT_ACK = 0; // input
   reg IOR_INT0; 
   wire IOR_RST_INT0;

rtavr top (.RESET(RESET), .CLK2X(CLK2X)

//		, .INT_VEC(INT_VEC[4:0])
//		, .INT_REQ(INT_REQ)
//		, .INT_ACK(INT_ACK)
		, .IOR_INT0(IOR_INT0)
		, .IOR_RST_INT0(IOR_RST_INT0)
 );

   parameter CLKP = 5000;        //  50ns
   parameter CLKH = CLKP/2;      //
   parameter CLKL = CLKP-CLKH;   //
   
   always begin
      #CLKH CLK2X = 0;
      #CLKL CLK2X = 1;
   end

`ifdef GTK
   initial begin
      $dumpfile("tb.vcd");
      $dumpvars(0,`MODULE.top);
   end
`endif

   initial begin : test
      sys_reset();
      while ( CLK_COUNT < `CLK_LIMIT)
      begin
         @(posedge CLK2X);
         @(posedge CLK2X);
         CLK_COUNT = CLK_COUNT + 1;
      end
      $display("*** Simulation Complete! ***");
      $finish;
   end

   task sys_reset;
      begin
   	 IOR_INT0 = 0; 
         CLK_COUNT = 0;
         #1 RESET = 0;
         CLK2X = 0;
         @(posedge CLK2X);
         @(posedge CLK2X);
	 @(negedge CLK2X);
         @(posedge CLK2X);
         #1 RESET = 1;
         @(posedge CLK2X);
         @(posedge CLK2X);
         CLK_COUNT = CLK_COUNT + 1;
      end
   endtask // sys_reset
   
endmodule // test
